package jia;

import static jason.asSyntax.ASSyntax.createString;
import static jason.asSyntax.ASSyntax.createNumber;

import java.util.Iterator;

import massim.agent.framework.AbstractAgent;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.StringTerm;
import jason.asSyntax.Term;

public class pos extends AbstractMasSimInternalAction {
	@Override
	public Object execute(TransitionSystem ts, final Unifier un, final Term[] args)
			throws Exception {

		
		final AbstractAgent agent = getAgent(ts);
		if ((agent == null) || (agent.getMap() == null))
			return false;
		
		NumberTerm x = (NumberTerm)args[0];
		NumberTerm y = (NumberTerm)args[1];
		
		if (!x.isVar() && !y.isVar()) {
			int x_val = new Double(x.solve()).intValue();
			int y_val = new Double(y.solve()).intValue();
			String value = agent.getMap().getMapField(x_val, y_val);
			return un.unifies(createString(value), args[2]);
		} else if (x.isVar() && y.isVar() && !args[2].isVar()) {
			final String value = ((StringTerm)args[2]).getString(); 
			return new Iterator<Unifier>() {

				int last_succ_x=0;
				int last_succ_y=0;
				int last_x=0;
				int last_y=0;				
				int size_x = agent.getMap().getSizeX();
				int size_y = agent.getMap().getSizeY();
				boolean finished = false;
				
				@Override
				public boolean hasNext() {
					return finished || (last_x < size_x) || (last_y < size_y);
				}

				@Override
				public Unifier next() {
					Unifier u = un.clone();
					while (agent.getMap().getMapField(last_x, last_y) != value) {
						last_x++;
						if (last_x == size_x) {
							last_x = 0;
							last_y++;
							if (last_y == size_y) {
								finished = true;
								u.unifies(createNumber(last_succ_x), args[0]);
								u.unifies(createNumber(last_succ_y), args[1]);
								return u;
							}
						}
					}
					last_succ_x = last_x;
					last_succ_y = last_y;
					u.unifies(createNumber(last_succ_x), args[0]);
					u.unifies(createNumber(last_succ_y), args[1]);
					return u;
				}

				@Override
				public void remove() { }
				
			};
		}
		
		return false;
	}
}
