package massim.agent.implementation;

import java.util.LinkedList;

import massim.agent.framework.AbstractAgent;
import massim.agent.implementation.ExampleAgent;

public class AgentLauncher {

	static LinkedList<AbstractAgent> agents = new LinkedList<AbstractAgent>();
	
	public static void main(String[] args)  {
		// create agents
		agents.add(new ExampleAgent("b1", "1"));
		agents.add(new ExampleAgent("b2", "1"));
		agents.add(new ExampleAgent("b3", "1"));
		agents.add(new ExampleAgent("b4", "1"));
		agents.add(new ExampleAgent("b5", "1"));
		
		// run the agents
		LinkedList<Thread> threads = new LinkedList<Thread>();
		
		for (AbstractAgent agent : agents) {
			Thread thread = new Thread(agent);
			threads.add(thread);
			thread.start();
		}
		
		// wait until the launched agents finish
		try {
			for (Thread thread : threads) {
					thread.join();
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
